package javax.management.relation;

import java.util.Map;
import javax.management.InstanceNotFoundException;
import javax.management.ObjectName;
import java.util.List;

public interface RelationServiceMBean
{
    public abstract void isActive() throws RelationServiceNotRegisteredException;
    
    public abstract boolean getPurgeFlag();
    
    public abstract void setPurgeFlag(boolean p0);
    
    public abstract void createRelationType(String p0, RoleInfo[] p1) throws IllegalArgumentException, InvalidRelationTypeException;
    
    public abstract void addRelationType(RelationType p0) throws IllegalArgumentException, InvalidRelationTypeException;
    
    public abstract List<String> getAllRelationTypeNames();
    
    public abstract List<RoleInfo> getRoleInfos(String p0) throws IllegalArgumentException, RelationTypeNotFoundException;
    
    public abstract RoleInfo getRoleInfo(String p0, String p1) throws IllegalArgumentException, RelationTypeNotFoundException, RoleInfoNotFoundException;
    
    public abstract void removeRelationType(String p0) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationTypeNotFoundException;
    
    public abstract void createRelation(String p0, String p1, RoleList p2) throws RelationServiceNotRegisteredException, IllegalArgumentException, RoleNotFoundException, InvalidRelationIdException, RelationTypeNotFoundException, InvalidRoleValueException;
    
    public abstract void addRelation(ObjectName p0) throws IllegalArgumentException, RelationServiceNotRegisteredException, NoSuchMethodException, InvalidRelationIdException, InstanceNotFoundException, InvalidRelationServiceException, RelationTypeNotFoundException, RoleNotFoundException, InvalidRoleValueException;
    
    public abstract ObjectName isRelationMBean(String p0) throws IllegalArgumentException, RelationNotFoundException;
    
    public abstract String isRelation(ObjectName p0) throws IllegalArgumentException;
    
    public abstract Boolean hasRelation(String p0) throws IllegalArgumentException;
    
    public abstract List<String> getAllRelationIds();
    
    public abstract Integer checkRoleReading(String p0, String p1) throws IllegalArgumentException, RelationTypeNotFoundException;
    
    public abstract Integer checkRoleWriting(Role p0, String p1, Boolean p2) throws IllegalArgumentException, RelationTypeNotFoundException;
    
    public abstract void sendRelationCreationNotification(String p0) throws IllegalArgumentException, RelationNotFoundException;
    
    public abstract void sendRoleUpdateNotification(String p0, Role p1, List<ObjectName> p2) throws IllegalArgumentException, RelationNotFoundException;
    
    public abstract void sendRelationRemovalNotification(String p0, List<ObjectName> p1) throws IllegalArgumentException, RelationNotFoundException;
    
    public abstract void updateRoleMap(String p0, Role p1, List<ObjectName> p2) throws IllegalArgumentException, RelationServiceNotRegisteredException, RelationNotFoundException;
    
    public abstract void removeRelation(String p0) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationNotFoundException;
    
    public abstract void purgeRelations() throws RelationServiceNotRegisteredException;
    
    public abstract Map<String, List<String>> findReferencingRelations(ObjectName p0, String p1, String p2) throws IllegalArgumentException;
    
    public abstract Map<ObjectName, List<String>> findAssociatedMBeans(ObjectName p0, String p1, String p2) throws IllegalArgumentException;
    
    public abstract List<String> findRelationsOfType(String p0) throws IllegalArgumentException, RelationTypeNotFoundException;
    
    public abstract List<ObjectName> getRole(String p0, String p1) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationNotFoundException, RoleNotFoundException;
    
    public abstract RoleResult getRoles(String p0, String[] p1) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationNotFoundException;
    
    public abstract RoleResult getAllRoles(String p0) throws IllegalArgumentException, RelationNotFoundException, RelationServiceNotRegisteredException;
    
    public abstract Integer getRoleCardinality(String p0, String p1) throws IllegalArgumentException, RelationNotFoundException, RoleNotFoundException;
    
    public abstract void setRole(String p0, Role p1) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationNotFoundException, RoleNotFoundException, InvalidRoleValueException, RelationTypeNotFoundException;
    
    public abstract RoleResult setRoles(String p0, RoleList p1) throws RelationServiceNotRegisteredException, IllegalArgumentException, RelationNotFoundException;
    
    public abstract Map<ObjectName, List<String>> getReferencedMBeans(String p0) throws IllegalArgumentException, RelationNotFoundException;
    
    public abstract String getRelationTypeName(String p0) throws IllegalArgumentException, RelationNotFoundException;
}
